import type {DeleteItemCommandInput} from '@aws-sdk/client-dynamodb'
import type {DDBReadOnlyClientConfiguration} from '../DDBReadOnlyClient'
import {mapKey} from './mapKey'

export const mapDeleteItemCommand = <
  Item extends object,
  PKName extends keyof Item,
  SKName extends keyof Item | never = never,
>(
  config: DDBReadOnlyClientConfiguration<Item, PKName, SKName>,
  partitionKey: Item[PKName],
  sortKey?: Item[SKName],
): DeleteItemCommandInput => {
  return {
    TableName: config.tableName,
    Key: mapKey(config, partitionKey, sortKey),
  }
}
