import type {AttributeValue, ScanCommandInput} from '@aws-sdk/client-dynamodb'
import type {DDBReadOnlyClientConfiguration} from '../DDBReadOnlyClient'

export const mapGetAllItemsCommand = <
  Item extends object,
  PKName extends keyof Item,
  SKName extends keyof Item | never = never,
>(
  config: DDBReadOnlyClientConfiguration<Item, PKName, SKName>,
  pageSize = 100,
  lastEvaluatedKey?: Record<string, AttributeValue>,
): ScanCommandInput => {
  return {
    TableName: config.tableName,
    IndexName: config.indexName,
    Limit: pageSize,
    ExclusiveStartKey: lastEvaluatedKey,
  }
}
