import type {AttributeValue} from '@aws-sdk/client-dynamodb'
import {marshall} from '@aws-sdk/util-dynamodb'
import type {DDBReadOnlyClientConfiguration} from '../DDBReadOnlyClient'

export const mapKey = <Item extends object, PKName extends keyof Item, SKName extends keyof Item | never = never>(
  config: DDBReadOnlyClientConfiguration<Item, PKName, SKName>,
  partitionKey: Item[PKName],
  sortKey?: Item[SKName],
): {[key: string]: AttributeValue} => {
  return config.sortKeyName && sortKey
    ? marshall({
        [config.partitionKeyName]: partitionKey,
        [config.sortKeyName]: sortKey,
      })
    : marshall({
        [config.partitionKeyName]: partitionKey,
      })
}
