import {$} from 'bun'

export const startDDBContainer = async (containerName = 'dynamodb-local') => {
  const {exitCode} = await $`docker run --name ${containerName} -d -p 8000:8000 amazon/dynamodb-local`
  if (exitCode > 0) process.exit(exitCode)

  let remainingTries = 50
  while (remainingTries--) {
    const httpCode = Bun.spawnSync(`curl -s -o /dev/null -I -w %{http_code} http://localhost:8000`.split(' '), {
      stdout: 'pipe',
    }).stdout.toString()
    if (httpCode !== '000') break

    await new Promise((resolve) => setTimeout(resolve, 100))
  }
}
